#include <stdio.h>
#include <stdlib.h>

typedef struct _automobil{
    int cijena;
    char naziv[31];
    struct _automobil *next;
}automobil;

automobil* ucitaj(int n)
{
    automobil *first=NULL, *new, *pom;
    int i;

    if(!n)
        return first;

    //ucitavanje prvog elementa
    first=(automobil*)malloc(sizeof(automobil));
    scanf(" %[^\n] %d", first->naziv, &first->cijena);

    //ucitavanje preostalih elemenata
    pom=first;
    for(i=1; i<n; i++){
        new=(automobil*)malloc(sizeof(automobil));
        scanf(" %[^\n] %d", new->naziv, &new->cijena);
        pom->next=new;
        pom=new;
    }
    pom->next=NULL;

    return first;
}

//prolazak kroz vezanu listu
void ispis(automobil* first)
{
    automobil* pom;

    for(pom=first; pom; pom=pom->next)
        printf("%s (%d)\n", pom->naziv, pom->cijena);
	printf("\n\n");

    return;
}

//dealokacija
void dealokacija(automobil* first)
{
    automobil *pom, *pom2;

    for(pom=first; pom; pom=pom2){
        pom2=pom->next;
        free(pom);
    }

    return;
}

//dodavanje na pocetak
automobil* dodaj_na_pocetak(automobil* first)
{
    automobil *new;

    new=(automobil*)malloc(sizeof(automobil));
    scanf(" %[^\n] %d", new->naziv, &new->cijena);

    new->next=first;
    first=new;

    return first;
}

//dodaj iza elementa na koji pokazuje tmp
void dodaj_ne_na_pocetak(automobil *tmp)
{
    automobil *new;

    new=(automobil*)malloc(sizeof(automobil));
    scanf(" %[^\n] %d", new->naziv, &new->cijena);

    new->next=tmp->next;
    tmp->next=new;

    return;
}

//Obrisi prvi element
automobil* obrisi_prvi(automobil* first)
{
    automobil* pom=first;

    first=first->next;
    free(pom);

    return first;
}

//Obrisi element iz elementa na kojeg pokazuje tmp
void obrisi_neprvog(automobil* tmp)
{
    automobil* pom=tmp->next;

    tmp->next=pom->next;
    free(pom);

    return;
}

int main(void)
{
    automobil *first=ucitaj(2);

    ispis(first);

	dodaj_ne_na_pocetak(first);
	first=dodaj_na_pocetak(first);
	ispis(first);

	obrisi_neprvog(first->next);
	first=obrisi_prvi(first);
	ispis(first);

    dealokacija(first);

    return 0;
}
